include("../../AoC2021.jl")

##

function parsefile(file)
    start = readline(file)

    readline(file)

    mapples = eachline(file) .|>
              (x -> split(x, " -> ")) .|>
              (x -> (x[1], x[2]))

    mapping = Dict(x => y for (x, y) ∈ mapples)

    (start, mapping)
end

function hist(string::String)
    h = Dict()

    for char ∈ collect(string)
        h[char] = get(h, char, 0) + 1
    end

    h
end

##

function task0(file)
    (poly, mapping) = parsefile(file)

    # display(poly)

    for _ = 1:10
        newpoly = ""
        for i ∈ 1:(length(poly)-1)
            pair = poly[i:(i+1)]
            newpair = join([pair[1], mapping[pair]])
            newpoly *= newpair
        end

        newpoly *= poly[end]
        # display(newpoly)
        poly = newpoly
    end

    h = hist(poly)
    return maximum(values(h)) - minimum(values(h))
end

##

verify(14, 1, 0, 1588)
verify(14, 1, 1, 2874)

##

function hist(pairs::Dict)
    h = Dict()

    for pair ∈ keys(pairs)
        # for char ∈ collect(pair)
            h[pair[1]] = get(h, pair[1], 0) + pairs[pair]
        # end
    end

    h
end

##

function task1(file)
    (poly, mapping) = parsefile(file)

    # display(poly)

    pairs = Dict()

    for i ∈ 1:(length(poly)-1)
        pair = poly[i:(i+1)]
        pairs[pair] = get(pairs, pair, 0) + 1
    end

    for _ = 1:40

        newpairs = Dict()

        for pair ∈ keys(pairs)
            lpair = join([pair[1], mapping[pair]])
            rpair = join([mapping[pair], pair[2]])

            newpairs[lpair] = get(newpairs, lpair, 0) + pairs[pair]
            newpairs[rpair] = get(newpairs, rpair, 0) + pairs[pair]
        end

        pairs = newpairs
    end

    h = hist(pairs)
    h[poly[end]] += 1
    return maximum(values(h)) - minimum(values(h))
end

##

verify(14, 2, 0, 2188189693529)
verify(14, 2, 1, 5208377027195)