include("../../AoC2021.jl")

using DataStructures

##

function parsefile(file)
    (eachline(file) .|> Base.Fix2(split, "") .|>
     (x -> parse.(Int, x)) .|>
     permutedims) |> x -> vcat(x...)
end

function A★cost(mappe)
    mappesize = size(mappe)
    mappeopt = fill(typemax(Int), mappesize)
    mappeopt[1, 1] = 0

    q = PriorityQueue()

    enqueue!(q, CartesianIndex(1, 1), sum(mappesize) - 2)

    while length(q) > 0
        (pos, costh) = dequeue_pair!(q)

        cost = costh - ((mappesize[1] - pos[1]) + (mappesize[2] - pos[2]))

        if pos == CartesianIndex(mappesize)
            return cost
        end

        for (x, y) ∈ [(-1, 0), (1, 0), (0, 1), (0, -1)]
            if checkbounds(Bool, mappe, pos + CartesianIndex(y, x))
                if cost + mappe[pos+CartesianIndex(y, x)] < mappeopt[pos+CartesianIndex(y, x)]
                    mappeopt[pos+CartesianIndex(y, x)] = cost + mappe[pos+CartesianIndex(y, x)]
                    q[pos+CartesianIndex(y, x)] = cost +
                                                  mappe[pos+CartesianIndex(y, x)] +
                                                  (mappesize[1] - (pos[1] + y)) + (mappesize[2] - (pos[2] + x))
                end
            end
        end
    end
end

##

function task0(file)
    mappe = parsefile(file)

    A★cost(mappe)
end

##

verify(15, 1, 0, 40)
verify(15, 1, 1, 769)

##

function task1(file)
    mappe = parsefile(file)
    newmappe = kron(ones(5, 5), mappe) .+ kron(collect(0:4)' .+ collect(0:4), ones(size(mappe)))
    newmappe = (convert.(Int, newmappe) .- 1) .% 9 .+ 1

    A★cost(newmappe)
end

##

verify(15, 2, 0, 315)
verify(15, 2, 1, 2963)